//+------------------------------------------------------------------+
//|                                          ind_All_Stochastics.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow

#property indicator_level1 20
#property indicator_level2 50
#property indicator_level3 80

//---- input parameters
extern int       K=5;
extern int       D=3;
extern int       S=3;
extern int       Length=25;
extern int       Shift=1; 
extern color     txtColor=Lime; 
int wn;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   SetIndexShift(0,Shift*(Length+1));
   SetIndexShift(1,Shift*(Length+1));   
   
   IndicatorShortName("ind_All_Stochastic");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
         
      int st_1=0;//iBarShift(NULL,1,Time[0],true);   
      int st_5=0;//iBarShift(NULL,5,Time[0],true);      
      int st_15=0;//iBarShift(NULL,15,Time[0],true);   
      int st_30=0;//iBarShift(NULL,30,Time[0],true);        
      int st_60=0;//iBarShift(NULL,60,Time[0],true);      
      int st_240=0;//iBarShift(NULL,240,Time[0],true);   
      int st_1440=0;//iBarShift(NULL,1440,Time[0],true);
      

         for(int i=0;i<Length;i++){
            ExtMapBuffer1[i]=iStochastic(NULL,1,K,D,S,0,0,0,i+st_1);
            ExtMapBuffer1[i+(Length+1)]=iStochastic(NULL,5,K,D,S,0,0,0,i+st_5);  
            ExtMapBuffer1[i+(Length+1)*2]=iStochastic(NULL,15,K,D,S,0,0,0,i+st_15);              
            ExtMapBuffer1[i+(Length+1)*3]=iStochastic(NULL,30,K,D,S,0,0,0,i+st_30);              
            ExtMapBuffer1[i+(Length+1)*4]=iStochastic(NULL,60,K,D,S,0,0,0,i+st_60);                        
            ExtMapBuffer1[i+(Length+1)*5]=iStochastic(NULL,240,K,D,S,0,0,0,i+st_240);   
            ExtMapBuffer1[i+(Length+1)*6]=iStochastic(NULL,1440,K,D,S,0,0,0,i+st_1440);  
            
            ExtMapBuffer2[i]=iStochastic(NULL,1,K,D,S,0,0,1,i+st_1);
            ExtMapBuffer2[i+(Length+1)]=iStochastic(NULL,5,K,D,S,0,0,1,i+st_5);  
            ExtMapBuffer2[i+(Length+1)*2]=iStochastic(NULL,15,K,D,S,0,0,1,i+st_15);              
            ExtMapBuffer2[i+(Length+1)*3]=iStochastic(NULL,30,K,D,S,0,0,1,i+st_30);              
            ExtMapBuffer2[i+(Length+1)*4]=iStochastic(NULL,60,K,D,S,0,0,1,i+st_60);                        
            ExtMapBuffer2[i+(Length+1)*5]=iStochastic(NULL,240,K,D,S,0,0,1,i+st_240);   
            ExtMapBuffer2[i+(Length+1)*6]=iStochastic(NULL,1440,K,D,S,0,0,1,i+st_1440);                                 
         }
         ExtMapBuffer1[Length]=EMPTY_VALUE;
         ExtMapBuffer1[Length*2+1]=EMPTY_VALUE;         
         ExtMapBuffer1[Length*3+2]=EMPTY_VALUE;         
         ExtMapBuffer1[Length*4+3]=EMPTY_VALUE;         
         ExtMapBuffer1[Length*5+4]=EMPTY_VALUE;         
         ExtMapBuffer1[Length*6+5]=EMPTY_VALUE;   
         
         ExtMapBuffer2[Length]=EMPTY_VALUE;
         ExtMapBuffer2[Length*2+1]=EMPTY_VALUE;         
         ExtMapBuffer2[Length*3+2]=EMPTY_VALUE;         
         ExtMapBuffer2[Length*4+3]=EMPTY_VALUE;         
         ExtMapBuffer2[Length*5+4]=EMPTY_VALUE;         
         ExtMapBuffer2[Length*6+5]=EMPTY_VALUE;  
         
         wn=WindowFind("ind_All_Stochastic");
         string on;
         
         on="AllSt_1440";
         
               if(ObjectFind(on)!=wn){
                  ObjectCreate(on,OBJ_TEXT,wn,0,0);
               }
            ObjectSet(on,OBJPROP_TIME1,MyTime(5+Length*6+5-Shift*(Length+1)));
            ObjectSet(on,OBJPROP_PRICE1,100);            
            ObjectSetText(on,"D1",8,"Arial",txtColor);
         
            
         on="AllSt_240";
         
               if(ObjectFind(on)!=wn){
                  ObjectCreate(on,OBJ_TEXT,wn,0,0);
               }
            ObjectSet(on,OBJPROP_TIME1,MyTime(5+Length*5+4-Shift*(Length+1)));
            ObjectSet(on,OBJPROP_PRICE1,100);            
            ObjectSetText(on,"H4",8,"Arial",txtColor);         
    
         on="AllSt_60";
         
               if(ObjectFind(on)!=wn){
                  ObjectCreate(on,OBJ_TEXT,wn,0,0);
               }
            ObjectSet(on,OBJPROP_TIME1,MyTime(5+Length*4+3-Shift*(Length+1)));
            ObjectSet(on,OBJPROP_PRICE1,100);            
            ObjectSetText(on,"H1",8,"Arial",txtColor);      
 
 
         on="AllSt_30";
         
               if(ObjectFind(on)!=wn){
                  ObjectCreate(on,OBJ_TEXT,wn,0,0);
               }
            ObjectSet(on,OBJPROP_TIME1,MyTime(5+Length*3+2-Shift*(Length+1)));
            ObjectSet(on,OBJPROP_PRICE1,100);            
            ObjectSetText(on,"M30",8,"Arial",txtColor);      
    
    
         on="AllSt_15";
         
               if(ObjectFind(on)!=wn){
                  ObjectCreate(on,OBJ_TEXT,wn,0,0);
               }
            ObjectSet(on,OBJPROP_TIME1,MyTime(5+Length*2+1-Shift*(Length+1)));
            ObjectSet(on,OBJPROP_PRICE1,100);            
            ObjectSetText(on,"M15",8,"Arial",txtColor);    
            
            
         on="AllSt_5";
         
               if(ObjectFind(on)!=wn){
                  ObjectCreate(on,OBJ_TEXT,wn,0,0);
               }
            ObjectSet(on,OBJPROP_TIME1,MyTime(5+Length*1-Shift*(Length+1)));
            ObjectSet(on,OBJPROP_PRICE1,100);            
            ObjectSetText(on,"M5",8,"Arial",txtColor);              
              
         on="AllSt_1";
         
               if(ObjectFind(on)!=wn){
                  ObjectCreate(on,OBJ_TEXT,wn,0,0);
               }
            ObjectSet(on,OBJPROP_TIME1,MyTime(5+Length*0-1-Shift*(Length+1)));
            ObjectSet(on,OBJPROP_PRICE1,100);            
            ObjectSetText(on,"M1",8,"Arial",txtColor);   
            
   SetIndexDrawBegin(0,Bars-7*(Length+1)+1);
   SetIndexDrawBegin(1,Bars-7*(Length+1)+1);              
                   
//----
   return(0);
  }
//+------------------------------------------------------------------+

int MyTime(int a){
   if(a<0){
      return(Time[0]+Period()*60*MathAbs(a));
   }
   else{
      return(Time[a]);   
   }
}